package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadWSValueCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadWSValueTask implements Runnable {
	
	private ACUClient client;
	private AppCommand appCommand;
	
	public ReadWSValueTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取甲烷参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadWSValueCommand wsCmd = (ReadWSValueCommand) appCommand;
		
		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(wsCmd.getCommandType());
		cmd.setDest(wsCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { wsCmd.getMemoryArea() }));
		cmd.setStart_mem_word(wsCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(wsCmd.getStartAddress().substring(4));
		cmd.setCount_word(wsCmd.getCountWord());
		cmd.setCount_bit(wsCmd.getCountBit());
		cmd.setCount_sensor(wsCmd.getCountSensor());
		cmd.setOffset(wsCmd.getOffset());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
